package cn.tonyandmoney.tuon.core.cros;

import cn.tonyandmoney.tuon.core.utils.CrosUtils;
import org.jetbrains.annotations.NotNull;
import org.springframework.core.Ordered;
import org.springframework.http.HttpMethod;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.http.server.reactive.ServerHttpResponse;
import org.springframework.web.server.ServerWebExchange;
import org.springframework.web.server.WebFilter;
import org.springframework.web.server.WebFilterChain;
import reactor.core.publisher.Mono;
import reactor.core.publisher.MonoSink;

import java.util.function.Consumer;

public class GlobalCrosFilter implements WebFilter, Ordered {
    @NotNull
    @Override
    public Mono<Void> filter(@NotNull ServerWebExchange exchange, @NotNull WebFilterChain chain) {
        return Mono.create((Consumer<MonoSink<HttpMethod>>) voidMonoSink -> {
            ServerHttpRequest httpRequest = exchange.getRequest();
            ServerHttpResponse httpResponse = exchange.getResponse();
            CrosUtils.allow(httpRequest, httpResponse);
            voidMonoSink.success(httpRequest.getMethod());
        }).flatMap(httpMethod -> {
            if (httpMethod == HttpMethod.OPTIONS) {
                return exchange.getResponse().setComplete();
            }
            return chain.filter(exchange);
        });
    }

    @Override
    public int getOrder() {
        return -2;
    }
}
