package cn.tonyandmoney.tuon.core.error;

import org.apache.commons.lang3.StringUtils;

/**
 * 操作异常，主动抛出的异常信息
 */
public class OpException extends RuntimeException {
    private int code;

    public OpException(int code) {
        this.code = code;
    }

    public OpException(int code, String message) {
        super(message);
        this.code = code;
    }

    public <T> BaseResp<T> toResp() {
        String message = getMessage();
        BaseResp<T> resp = new BaseResp<>();
        if (!StringUtils.isBlank(message)) {
            resp.setMessage(message);
        }
        resp.setCode(code);
        return resp;
    }
}
