package cn.tonyandmoney.tuon.core.utils;

import org.apache.commons.lang3.StringUtils;
import org.springframework.http.HttpHeaders;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.http.server.reactive.ServerHttpResponse;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

public class CrosUtils {

    public static void allow(ServerHttpRequest request, ServerHttpResponse response) {
        HttpHeaders headers = response.getHeaders();
        List<String> origins = request.getHeaders().get("Origin");
        if (origins != null && !origins.isEmpty()) {
            headers.set("Access-control-Allow-Origin", origins.get(0));
        }
        headers.set("Access-Control-Allow-Methods", "GET, HEAD, POST, PUT, DELETE, TRACE, OPTIONS, PATCH");
        headers.set("Access-Control-Allow-Credentials", "true");
        headers.set("Access-Control-Allow-Headers", StringUtils.join(headers.get("Access-Control-Request-Headers"), ","));
    }

    public static void allow(HttpServletRequest request, HttpServletResponse response) {

        String origin = request.getHeader("Origin");
        if (!StringUtils.isEmpty(origin)) {
            response.setHeader("Access-control-Allow-Origin", origin);
        }
        response.setHeader("Access-Control-Allow-Methods", "GET, HEAD, POST, PUT, DELETE, TRACE, OPTIONS, PATCH");
        response.setHeader("Access-Control-Allow-Credentials", "true");
        response.setHeader("Access-Control-Allow-Headers", request.getHeader("Access-Control-Request-Headers"));
    }

}
