package cn.tonyandmoney.tuon.core.utils;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

/**
 * 日期工具类
 */
public class DateUtils {

    /**
     * 日期格式
     */
    public static final String F_YYYYMMDD = "yyyy-MM-dd";

    /**
     * 获取当天的日期
     *
     * @return
     */
    public static Date today() {
        Calendar calendar = Calendar.getInstance(Locale.CHINA);
        return calendar.getTime();
    }


    /**
     * 格式化日期
     *
     * @param date    日期
     * @param pattern 模式
     * @return 日期字符串
     */
    public static String format(Date date, String pattern) {
        SimpleDateFormat dateFormat = new SimpleDateFormat(pattern, Locale.CHINA);
        return dateFormat.format(date);
    }


}
