package cn.tonyandmoney.tuon.core.utils;

import org.springframework.http.HttpEntity;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;

import java.util.Map;

public class RestUtils {


    /**
     * post请求
     *
     * @param host 主机地址
     * @param url  路径
     * @param body 消息内容
     * @param clz  返回数据类型
     * @param <T>  返回数据类型
     * @return 响应
     */
    public static <T> T post(String host, String url, HttpEntity body, Map<String, String> params, Class<T> clz) {
        RestTemplate restTemplate = new RestTemplate(createFactory());
        return restTemplate.postForObject(String.format("%s%s", host, url), body, clz, params);
    }


    public static <T> T get(String url, Map<String, String> params, Class<T> clz) {
        RestTemplate restTemplate = new RestTemplate(createFactory());
        return restTemplate.getForObject(url, clz, params);
    }

    public static <T> T get(String host, String url, Map<String, String> params, Class<T> clz) {
        RestTemplate restTemplate = new RestTemplate(createFactory());
        return restTemplate.getForObject(String.format("%s%s", host, url), clz, params);
    }


    private static SimpleClientHttpRequestFactory createFactory() {
        SimpleClientHttpRequestFactory requestFactory = new SimpleClientHttpRequestFactory();
        requestFactory.setConnectTimeout(1000);
        requestFactory.setReadTimeout(1000);
        return requestFactory;
    }
}
