package cn.gygxzc.envir.core.orm.injector.method

import cn.gygxzc.envir.core.orm.injector.enums.SqlMethodCopy
import com.baomidou.mybatisplus.core.injector.AbstractMethod
import com.baomidou.mybatisplus.core.metadata.TableInfo
import com.baomidou.mybatisplus.core.toolkit.Constants
import org.apache.ibatis.mapping.MappedStatement

/**
 * Created by niantuo on 2018/9/29.
 */

class UpdateById : AbstractMethod() {
    override fun injectMappedStatement(mapperClass: Class<*>, modelClass: Class<*>, tableInfo: TableInfo): MappedStatement {
        val sqlMethod = SqlMethodCopy.UPDATE_BY_ID
        val sql = String.format(sqlMethod.sql, tableInfo.tableName,
                sqlSet(false, false, tableInfo, Constants.ENTITY_SPOT),
                tableInfo.keyColumn, Constants.ENTITY_SPOT + tableInfo.keyProperty,
                StringBuilder("<if test=\"et instanceof java.util.Map\">")
                        .append("<if test=\"et.MP_OPTLOCK_VERSION_ORIGINAL!=null\">")
                        .append(" AND \${et.MP_OPTLOCK_VERSION_COLUMN}=#{et.MP_OPTLOCK_VERSION_ORIGINAL}")
                        .append("</if></if>"))
        val sqlSource = languageDriver.createSqlSource(configuration, sql, modelClass)
        return addUpdateMappedStatement(mapperClass, modelClass, sqlMethod.method, sqlSource)
    }
}