package cn.tonyandmoney.tuon.core.config

import cn.tonyandmoney.tuon.core.properties.CustomConfigProperties
import cn.tonyandmoney.tuon.core.session.filter.SessionFillFilter
import org.springframework.boot.autoconfigure.condition.ConditionalOnWebApplication
import org.springframework.boot.context.properties.EnableConfigurationProperties
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.core.annotation.Order
import org.springframework.session.data.redis.config.annotation.web.http.EnableRedisHttpSession
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport
import javax.servlet.Filter

/**
 * Created by niantuo on 2018/9/20.
 * mvc 配置
 * 实际上这个配置无所谓有没有了
 */
@Configuration
@EnableRedisHttpSession
@EnableConfigurationProperties(CustomConfigProperties::class)
@ConditionalOnWebApplication(type = ConditionalOnWebApplication.Type.SERVLET)
class CustomWebMvcConfiguration : WebMvcConfigurationSupport() {


    override fun addResourceHandlers(registry: ResourceHandlerRegistry) {
        super.addResourceHandlers(registry)
        registry.addResourceHandler("swagger-ui.html")
                .addResourceLocations("classpath:/META-INF/resources/")


        registry.addResourceHandler("/webjars*")
                .addResourceLocations("classpath:/META-INF/resources/webjars/")
    }


    /**
     * session注入和移除
     */
    @Bean
    fun sessionFilter(): Filter {
        return SessionFillFilter()
    }

}