package cn.tonyandmoney.tuon.core.config.reactive

import cn.tonyandmoney.tuon.core.properties.CustomConfigProperties
import org.springframework.boot.autoconfigure.condition.ConditionalOnWebApplication
import org.springframework.boot.context.properties.EnableConfigurationProperties
import org.springframework.context.annotation.Configuration
import org.springframework.web.reactive.config.ViewResolverRegistry
import org.springframework.web.reactive.config.WebFluxConfigurationSupport

/**
 * 什么配置
 */
@Configuration
@EnableConfigurationProperties(CustomConfigProperties::class)
@ConditionalOnWebApplication(type = ConditionalOnWebApplication.Type.REACTIVE)
class ReactiveCoreConfiguration : WebFluxConfigurationSupport() {


    /**
     * 配置视图解析
     */
    override fun configureViewResolvers(registry: ViewResolverRegistry) {
        super.configureViewResolvers(registry)
    }


}