package cn.tonyandmoney.tuon.qywx.bean;

/**
 * 应用通过企业微信接口向用户主动推送的消息实体类
 */
public class WxMsgTo {
    /**
     * 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为@all，则向该企业应用的全部成员发送
     */
    private String touser;
    /**
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为@all时忽略本参数
     */
    private String toparty;
    private String totag;
    /**
     * 消息类型，此时固定为：text
     */
    private String msgtype = "text";
    /**
     * 企业应用的id，整型。企业内部开发，可在应用的设置页面查看；第三方服务商，可通过接口 获取企业授权信息 获取该参数值
     */
    private String agentid;
    private Text text;
    private int safe = 0;  //表示是否是保密消息，0表示否，1表示是，默认0
    private int enable_id_trans;//表示是否开启id转译，0表示否，1表示是，默认0


    public String getTouser() {
        return touser;
    }

    public void setTouser(String touser) {
        this.touser = touser;
    }

    public String getToparty() {
        return toparty;
    }

    public void setToparty(String toparty) {
        this.toparty = toparty;
    }

    public String getTotag() {
        return totag;
    }

    public void setTotag(String totag) {
        this.totag = totag;
    }

    public String getMsgtype() {
        return msgtype;
    }

    public void setMsgtype(String msgtype) {
        this.msgtype = msgtype;
    }

    public String getAgentid() {
        return agentid;
    }

    public void setAgentid(String agentid) {
        this.agentid = agentid;
    }

    public void setText(Text text) {
        this.text = text;
    }

    public Text getText() {
        return text;
    }

    public int getSafe() {
        return safe;
    }

    public void setSafe(int safe) {
        this.safe = safe;
    }

    public int getEnable_id_trans() {
        return enable_id_trans;
    }

    public void setEnable_id_trans(int enable_id_trans) {
        this.enable_id_trans = enable_id_trans;
    }


    public static class Text {
        private String content;

        public void setContent(String content) {
            this.content = content;
        }

        public String getContent() {
            return content;
        }

        @Override
        public String toString() {
            return "WxMsgTo.Text { content:  " + content + "}\n";
        }
    }

    @Override
    public String toString() {
        return "WxMsgTo:{" +
                "touser:" + touser + " " +
                "msgtype:" + msgtype + " " +
                "text : " + text + "}";
    }
}
