package cn.tonyandmoney.tuon.qywx.bean;

import cn.tonyandmoney.tuon.core.user.IDept;
import cn.tonyandmoney.tuon.core.user.IRole;
import cn.tonyandmoney.tuon.core.user.IUser;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;

/**
 * 企业微信的用户信息
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class WxUser extends WxBaseResult implements Serializable, IUser {
    public static final long serialVersionUID = 1L;

    private String userid;
    private String name;
    private List<Long> department;
    private List<Integer> order;
    private String position;
    private String mobile;
    private String gender;
    private String email;
    private List<Long> is_leader_in_dept;
    private String avatar;
    private String telephone;
    private boolean enable;
    private String address;
    private int status;
    private String qr_code;
    private String external_position;


    public String getUserid() {
        return userid;
    }

    public void setUserid(String userid) {
        this.userid = userid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Long> getDepartment() {
        return department;
    }

    public void setDepartment(List<Long> department) {
        this.department = department;
    }

    public List<Integer> getOrder() {
        return order;
    }

    public void setOrder(List<Integer> order) {
        this.order = order;
    }

    public String getPosition() {
        return position;
    }

    public void setPosition(String position) {
        this.position = position;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public String getGender() {
        return gender;
    }

    public void setGender(String gender) {
        this.gender = gender;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public List<Long> getIs_leader_in_dept() {
        return is_leader_in_dept;
    }

    public void setIs_leader_in_dept(List<Long> is_leader_in_dept) {
        this.is_leader_in_dept = is_leader_in_dept;
    }

    public String getAvatar() {
        return avatar;
    }

    public void setAvatar(String avatar) {
        this.avatar = avatar;
    }

    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    public boolean isEnable() {
        return enable;
    }

    public void setEnable(boolean enable) {
        this.enable = enable;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public String getQr_code() {
        return qr_code;
    }

    public void setQr_code(String qr_code) {
        this.qr_code = qr_code;
    }

    public String getExternal_position() {
        return external_position;
    }

    public void setExternal_position(String external_position) {
        this.external_position = external_position;
    }

    @Override
    public String toString() {
        return "WxUser{ id: " + userid + "}";
    }

    @Override
    public String getUserId() {
        return userid;
    }

    @Override
    public String getUsername() {
        return name;
    }

    @Override
    public String getAccount() {
        return userid;
    }

    @Override
    public List<IDept> getDepts() {
        return Collections.emptyList();
    }

    @Override
    public List<IRole> getRoles() {
        return Collections.emptyList();
    }
}
