package cn.tonyandmoney.tuon.qywx

import cn.tonyandmoney.tuon.qywx.aes.WXBizMsgCrypt
import cn.tonyandmoney.tuon.qywx.service.IQywxService
import cn.tonyandmoney.tuon.qywx.service.impl.QywxServiceImpl
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.context.properties.EnableConfigurationProperties
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.data.redis.core.StringRedisTemplate

@Configuration
@EnableConfigurationProperties(QywxProperties::class)
class QywxConfiguration {

    @Autowired
    private lateinit var mProperties: QywxProperties


    @Bean
    fun qywxService(stringRedisTemplate: StringRedisTemplate): IQywxService {
        return QywxServiceImpl(stringRedisTemplate, mProperties)
    }


    @Bean
    fun bizMsgCrypt():WXBizMsgCrypt{
        return WXBizMsgCrypt(mProperties.token,mProperties.encodingAESKey,mProperties.corpid)
    }

}