package cn.tonyandmoney.tuon.qywx.controller

import cn.tonyandmoney.tuon.core.utils.DateUtils
import cn.tonyandmoney.tuon.qywx.entity.TDuty
import cn.tonyandmoney.tuon.qywx.service.IDutyService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*
import reactor.core.publisher.Mono
import java.util.*

/**
 * 值班信息接口
 */
@RestController
@RequestMapping("/duty")
class DutyController {

    @Autowired
    private lateinit var dutyService: IDutyService


    /**
     * 单个添加值班信息
     */
    @PostMapping
    fun addDuty(@RequestBody duty: TDuty): Mono<Void> {
        return dutyService.addDuty(duty)
    }


    /**
     * 根据日期查询值班信息，如果没有传递日期，则默认为当天
     * 未进行分页
     */
    @GetMapping
    fun queryDutyByDate(@RequestParam("date", required = false) date: Date?): Mono<List<TDuty>> {
        return dutyService.queryByDate(date ?: DateUtils.today())
    }


}