package cn.tonyandmoney.tuon.qywx.controller

import cn.tonyandmoney.tuon.core.error.BaseResp
import cn.tonyandmoney.tuon.qywx.service.ISearchService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.RestController
import reactor.core.publisher.Flux

/**
 * 设定关键词，进行搜索，返回指定的数据
 */
@RestController
@RequestMapping("/wx/search")
class GlobalSearchController {

    @Autowired
    private lateinit var searchHandlers: List<ISearchService>

    /**
     * 搜索接口，设定关键词，
     */
    @GetMapping
    fun search(@RequestParam("keywords") keywords: String): Flux<BaseResp<*>> {
        return Flux.concat(searchHandlers.filter { it.apply(keywords) }.map { it.search(keywords) })
    }

}