package cn.tonyandmoney.tuon.qywx.entity

import com.baomidou.mybatisplus.annotation.IdType
import com.baomidou.mybatisplus.annotation.TableId
import com.baomidou.mybatisplus.annotation.TableName
import com.fasterxml.jackson.annotation.JsonFormat
import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import com.fasterxml.jackson.annotation.JsonInclude
import java.util.*

/**
 * 值班表
 * @property userId 用户ID
 * @property userName 用户姓名
 * @property dutyDate 值班的日期
 */
@TableName("t_duty")
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
data class TDuty(
        @TableId(type = IdType.ID_WORKER)
        var id: Long? = null,
        var userId: String? = null,
        var userName: String? = null,
        @JsonFormat(pattern = "yyyy-MM-dd")
        var dutyDate: Date? = null,
        var createBy: String? = null,
        @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
        var createTime: Date? = null,
        var updateBy: String? = null,
        @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
        var updateTime: Date? = null,
        var remark: String? = null) {
}