package cn.tonyandmoney.tuon.qywx.service

import cn.tonyandmoney.tuon.core.error.BaseResp
import cn.tonyandmoney.tuon.qywx.search.SearchResult
import reactor.core.publisher.Mono

/**
 * 指定一个搜索的服务，能提供搜索结果的service都实现该接口
 */
interface ISearchService {


    /**
     * 判断是否响应该关键词，
     * 如果能，则返回true
     */
    fun apply(keywords: String): Boolean

    /**
     * 进行搜索操作，返回数据
     */
    fun search(keywords: String): Mono<BaseResp<List<SearchResult>>>
}